import Qt 4.7
import "imports/colibri"
import "imports/XAComponents"
import "AICalendarPickerJS.js" as XACalJS

Rectangle {
    id: aiRepeatPicker

    color: "transparent"

    property int pickerDirection : qtPickerDirection;
    property int pickerTopSpacer : (pickerDirection == 2) ? 16 : 0
    property int pickerBottomSpacer : (pickerDirection == 2) ? 0 : 16

    property string windowGotFocus : qtWindowGotFocus
    property string dtsrepeat : qtInputDTSRepeat

    property bool enabled: true

    function onPresetValuesCompleted() {
//        console.debug("QML XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX VALUES LOADED.");
//        console.debug(dtsrepeat + " / " + qtInputDTSRepeat)

        dtsrepeat = qtInputDTSRepeat;
        xaqmlrepeatdatepicker.dtsRepeatString = dtsrepeat
    }

//    onFocusChanged: console.debug("AIRepeatPicker: focus changed.")

    Component.onCompleted: {
//        console.debug("QML XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX Component.onCompleted.");
    }

    function doOp(newRepeatString) {
        dtsrepeat = newRepeatString;
        QtHandler.repeatStringUpdated(newRepeatString)
    }

    //
    // close tabs for different picker directions
    //

    Rectangle {
        id: closeTabTop
        anchors.top: parent.top
        anchors.left: parent.left
        anchors.leftMargin: parent.width / 2 - 7
        width: 16
        height: 30

        color: "#99222222"
        visible: (pickerDirection == 2)

        Image {
            anchors.left: parent.left
            anchors.top: parent.top
            source: "imports/XAComponents/pics/PreviewIconRepeatPopupButtonPressed16px.png"
        }

        MouseArea {
            id: closeTabTopMouseArea
            anchors.fill: parent

            onClicked: QtWindow.hide();
        }
    }

    Rectangle {
        id: closeTabBottom
        anchors.bottom: parent.bottom
        anchors.left: parent.left
        anchors.leftMargin: parent.width / 2 - 7
        width: 16
        height: 30

        color: "#99222222"
        visible: (pickerDirection == 1)

        Image {
            anchors.left: parent.left
            anchors.bottom: parent.bottom
            source: "imports/XAComponents/pics/PreviewIconRepeatPopupButtonPressed16px.png"
        }

        MouseArea {
            id: closeTabBottomMouseArea
            anchors.fill: parent

            onClicked: QtWindow.hide();
        }
    }

    //
    // window content
    //

    Rectangle {
        id: contentRectangle
        anchors.top: parent.top
        anchors.topMargin: pickerTopSpacer
        anchors.bottomMargin: pickerBottomSpacer
        anchors.left: parent.left
        anchors.right: parent.right
        height: xaqmlrepeatdatepicker.height

        gradient: Gradient {
            GradientStop { position: 0; color: "#222222" }
            GradientStop { position: 0.5; color: "#3f3b3c" }
            GradientStop { position: 1; color: "#222222" }
        }

        radius: 0
        smooth: true

        XAQMLRepeatDatePicker {
            id: xaqmlrepeatdatepicker
            anchors.fill: parent

            enabled: true

            onRepeatStringResultUpdated: aiRepeatPicker.doOp(dtsRepeatChanged);
        }

    }

}


