import Qt 4.7
import "../../imports/colibri"
import "../../imports/XAComponents"

Item {
    id: xaqlmlAddressBookPicker
//    width: 250
//    height: 364

    property bool enabled: true
    property int tempSliderHeight

    signal entrySelectionChanged(string uid)

    Rectangle {
        id: attachmentBrowserRect
        anchors.left: parent.left
        anchors.leftMargin: 4
        anchors.right: parent.right
        anchors.rightMargin: 4
        anchors.top: parent.top
        anchors.topMargin: 4
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 4
        clip: true
        color: "#222222"
        //color: "green"

        XACLScrollBarVertical {
            id: verticalScrollBar

            width: 12
            anchors.top: parent.top
            anchors.right: parent.right
            anchors.bottom: parent.bottom

            sledRoundness: 8
            buttonRoundness: 0

            minimum: 0
            maximum: (treeView.contentHeight - xaqlmlAddressBookPicker.height) + 10
            step: 22

            visible: (treeView.contentHeight > xaqlmlAddressBookPicker.height)

            next.height: 10

            onValueChanged: {
                treeView.contentY = value
//                console.debug("XAQMLAddressBookPicker verticalScrollBar onValueChanged")
//                console.debug(treeView.height)
//                console.debug(treeView.contentHeight)
            }
        }

        ListView  {
            id :  treeView
            anchors.top: parent.top
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.rightMargin: (treeView.contentHeight > xaqlmlAddressBookPicker.height) ? verticalScrollBar.width + 2 : 0
            anchors.bottom: parent.bottom

            model: contextModel
            delegate: treeDelegate

            onFocusChanged: {
//                console.debug("XAQMLAddressBookPicker treeView got Focus")
//                console.debug(treeView.height)
            }

            onModelChanged: {
//                console.debug("<< onModelChanged:New Model set for Context treeView")
                if (treeView.count == 0) {
                    //attachmentBrowser.urlString = "about:blank"
                    //attachmentBrowserRect.color = "darkgray"
                }
            }

            onContentHeightChanged: {
                tempSliderHeight = Math.round((verticalScrollBar.height-50) / (treeView.contentHeight / xaqlmlAddressBookPicker.height));
//                console.debug("XAQMLAddressBookPicker treeView onContentHeightChanged")
//                console.debug(tempSliderHeight)
//                console.debug(Math.round((verticalScrollBar.height-50) / (treeView.contentHeight / xaqlmlAddressBookPicker.height)))

                if (tempSliderHeight < 60) tempSliderHeight = 60
                verticalScrollBar.sledHeight = tempSliderHeight;
            }

            onContentYChanged: {
                verticalScrollBar.value = contentY
            }
        }


        // Component  delegate
        Component  {
            id:  treeDelegate
            Rectangle  {
                id :  wrapper
                height :  22
                width :  treeView.width

                //color: (index%2 == 0) ? "#44444444" : "#00000000"
                color: (index%2 == 0) ? "#1a1a1a" : "#2a2a2a"

                Rectangle  {
                    id:  levelMarginElement
                    // Starting  with  six  levels  of nesting  does not  shift the  descendants
                    // So  how  else  can  get a  very  wide  window
                    width :  (level > 5 ? 6 : level) * 10  +  5
                    anchors.left: parent.left
                }

                // Field  for  the opening / closing  descendants.
                // In  leaves  no  visible
                Item  {
                    id:  nodeOpenElement
                    anchors.left:  levelMarginElement.right
                    anchors.verticalCenter:  wrapper.verticalCenter
                    height:  20
                    state:  "leafnode"
                    Image  {
                        id:  triangleOpenImage
                        //fillMode: Image.PreserveAspectFit
                        height: 16
                        width: 16
                        anchors.top: parent.top
                        //anchors.topMargin: 1

                        source :  isSelectedImagePath

                        // Catches  clicking  the mouse  and  open / close  element
                        MouseArea  {
                            anchors.fill:  parent
                            onClicked:  {
                                if (hasChildren) {
                                    //(isOpened)  ? contextModel.closeItem (index) : contextModel.openItem (index)

                                    // sub-view navigation (iPhone style)
                                    //treeView.model.rootIndex = treeView.model.modelIndex(index)
                                }
                                contextModel.switchSelectionOnItem(index)

//                                console.debug("Item Clicked -> ")
//                                console.debug(subject)
//                                console.debug(isSelected)

                                entrySelectionChanged(uid);
                            }
                        }
                    }
                    states :  [
                        State  {
                            name: "leafnode"
                            when: isSelected
                            PropertyChanges  {
                                target:  nodeOpenElement;
                                visible:  true;
                                width:  20;
                            }
                            PropertyChanges  {
                                target :  triangleOpenImage
                                //source :  "qrc:icons/73-radar.png"
                                //source :  "qrc:icons2/checkbox-selected.png"

                            }
                        },
                        State  {
                            name: "leafnode"
                            when: !isSelected
                            PropertyChanges  {
                                target:  nodeOpenElement;
                                visible:  true;
                                width:  20;
                            }
                            PropertyChanges  {
                                target :  triangleOpenImage
                                //source :  "qrc:icons2/checkbox-deselected.png"
                            }
                        }

                    ]
                }

                // Field  for  displaying  data  element
                Text  {
                    id:  nameTextElement
                    text:  subject

                    anchors.left:  nodeOpenElement.right
                    anchors.leftMargin: 0
                    anchors.top:  parent.top
                    anchors.topMargin: 3
                    anchors.bottom:  parent.bottom
                    anchors.right:  parent.right
                    color: "white"

                    clip: true

                    //font.family: "Helvetica";
                    font.family: "Arial"
                    font.bold: false;
                    //font.pointSize: 11;
                    font.pixelSize: 11
                    smooth: true;
                }

            }

        }
    }


}
