import Qt 4.7

Item {
    id: xaqlmlRepeatDatePicker
    width: 250
    height: 364

    property bool enabled: true

    property string dtsRepeatString : ""
    property string dtsRepeatChanged

    property int repeaterTypeSegmentSelected

    property int repeatInterval: 1

    property string weekdayCheckPattern: "1000000"

    property int monthlySegmentSelected: 1
    property int dayOfMonthCheck: 1

    property int yearlySegmentSelected: 1
    property int monthInYearCheck: 1
    property int dayInYearCheck: 1

    signal repeatStringResultUpdated()

    onDtsRepeatStringChanged: {
//        console.debug("onDtsRepeatStringChanged")
//        console.debug(dtsRepeatString)

        if (dtsRepeatString.length < 3) repeaterTypeSegmentSelected = 0;
        else if (dtsRepeatString.charAt(0) == "d") repeaterTypeSegmentSelected = 1;
        else if (dtsRepeatString.charAt(0) == "w") repeaterTypeSegmentSelected = 2;
        else if (dtsRepeatString.charAt(0) == "m") repeaterTypeSegmentSelected = 3;
        else if (dtsRepeatString.charAt(0) == "y") repeaterTypeSegmentSelected = 4;

        segmentGrid.currentIndex = repeaterTypeSegmentSelected

        if (dtsRepeatString.length >= 3) {
            repeatInterval = parseInt(dtsRepeatString.substring(1,3))
            repeatDaySpecifierInputNumber.text = repeatInterval

            // parse week selection details
            if (dtsRepeatString.charAt(0) == "w" && dtsRepeatString.length == 11) {
                weekdayCheckPattern = dtsRepeatString.substring(4,11)
//                console.debug(weekdayCheckPattern)
            }

            // parse monthly selection details
            if (dtsRepeatString.charAt(0) == "m") {
                monthlySegmentSelected = parseInt(dtsRepeatString.substring(4,5))
//                console.debug(monthlySegmentSelected)

                segmentGridMonthlyCycle.currentIndex = monthlySegmentSelected

                dayOfMonthCheck = parseInt(dtsRepeatString.substring(6,8)) + 1
//                console.debug(dayOfMonthCheck)
            }

            // parse yearly selection details
            if (dtsRepeatString.charAt(0) == "y") {
                yearlySegmentSelected = parseInt(dtsRepeatString.substring(4,5))
//                console.debug(yearlySegmentSelected)

                segmentGridYearlyCycle.currentIndex = yearlySegmentSelected

                monthInYearCheck = parseInt(dtsRepeatString.substring(6,8)) + 1
//                console.debug(monthInYearCheck)

                dayInYearCheck = parseInt(dtsRepeatString.substring(9,11)) + 1
//                console.debug(dayInYearCheck)
            }
        }
    }

    function pad(number, length) {
        if (number < 0) return "";

        var str = '' + number;
        while (str.length < length) str = '0' + str;

        return str;
    }

    function updateDtsRepeatString() {
//        console.debug("updateDtsRepeatString")
//        console.debug(repeaterTypeSegmentSelected)

        if (repeaterTypeSegmentSelected == 0) {
            // none
            dtsRepeatChanged = ""
        } else if (repeaterTypeSegmentSelected == 1) {
            // daily
            dtsRepeatChanged = "d" + pad(repeatInterval, 2)
        } else if (repeaterTypeSegmentSelected == 2) {
            // weekly
            dtsRepeatChanged = "w" + pad(repeatInterval, 2) + ":" + weekdayCheckPattern
        } else if (repeaterTypeSegmentSelected == 3) {
            // monthly
            dtsRepeatChanged = "m" + pad(repeatInterval, 2) + ":" + monthlySegmentSelected + ":" + pad(dayOfMonthCheck-1, 2)
        } else if (repeaterTypeSegmentSelected == 4) {
            // yearly
            dtsRepeatChanged = "y" + pad(repeatInterval, 2) + ":" + yearlySegmentSelected + ":" + pad(monthInYearCheck-1, 2) + ":" + pad(dayInYearCheck-1, 2)
        }

//        console.debug(dtsRepeatString)
//        console.debug(dtsRepeatChanged)
        repeatStringResultUpdated()
    }

    ListModel {
        id: segmentModel

        ListElement {
            name: "None"
            checked: "1"
        }
        ListElement {
            name: "Daily"
            checked: "0"
        }
        ListElement {
            name: "Weekly"
            checked: "0"
        }
        ListElement {
            name: "Monthly"
            checked: "0"
        }
        ListElement {
            name: "Yearly"
            checked: "0"
        }

        function i18n(index) {
            if (i18n["text"] === undefined) {
                i18n.text = [
                            qsTr("None"),
                            qsTr("Daily"),
                            qsTr("Weekly"),
                            qsTr("Monthly"),
                            qsTr("Yearly")
                        ]
            }
            return i18n.text[index]
        }
    }

    ListModel {
        id: weekdayModel

        ListElement { name: "Sunday" }
        ListElement { name: "Monday" }
        ListElement { name: "Tuesday" }
        ListElement { name: "Wednesday" }
        ListElement { name: "Thursday" }
        ListElement { name: "Friday" }
        ListElement { name: "Saturday" }

        function i18n(index) {
            if (i18n["text"] === undefined) {
                i18n.text = [
                            qsTr("Sunday"),
                            qsTr("Monday"),
                            qsTr("Tuesday"),
                            qsTr("Wednesday"),
                            qsTr("Thursday"),
                            qsTr("Friday"),
                            qsTr("Saturday")
                        ]
            }
            return i18n.text[index]
        }
    }

    ListModel {
        id: nameOfMonthModel

        ListElement { name: "January" }
        ListElement { name: "February" }
        ListElement { name: "March" }
        ListElement { name: "April" }
        ListElement { name: "May" }
        ListElement { name: "June" }
        ListElement { name: "July" }
        ListElement { name: "August" }
        ListElement { name: "September" }
        ListElement { name: "October" }
        ListElement { name: "November" }
        ListElement { name: "December" }

        function i18n(index) {
            if (i18n["text"] === undefined) {
                i18n.text = [
                            qsTr("January"),
                            qsTr("February"),
                            qsTr("March"),
                            qsTr("April"),
                            qsTr("May"),
                            qsTr("June"),
                            qsTr("July"),
                            qsTr("August"),
                            qsTr("September"),
                            qsTr("October"),
                            qsTr("November"),
                            qsTr("December")
                        ]
            }
            return i18n.text[index]
        }
    }

    ListModel {
        id: dayOfMonthModel

        ListElement { name: "1" }
        ListElement { name: "2" }
        ListElement { name: "3" }
        ListElement { name: "4" }
        ListElement { name: "5" }
        ListElement { name: "6" }
        ListElement { name: "7" }
        ListElement { name: "8" }
        ListElement { name: "9" }
        ListElement { name: "10" }
        ListElement { name: "11" }
        ListElement { name: "12" }
        ListElement { name: "13" }
        ListElement { name: "14" }
        ListElement { name: "15" }
        ListElement { name: "16" }
        ListElement { name: "17" }
        ListElement { name: "18" }
        ListElement { name: "19" }
        ListElement { name: "20" }
        ListElement { name: "21" }
        ListElement { name: "22" }
        ListElement { name: "23" }
        ListElement { name: "24" }
        ListElement { name: "25" }
        ListElement { name: "26" }
        ListElement { name: "27" }
        ListElement { name: "28" }
        ListElement { name: "29" }
        ListElement { name: "30" }
        ListElement { name: "31" }

        function i18n(index) {
            if (i18n["text"] === undefined) {
                i18n.text = [
                            qsTr("1"),
                            qsTr("2"),
                            qsTr("3"),
                            qsTr("4"),
                            qsTr("5"),
                            qsTr("6"),
                            qsTr("7"),
                            qsTr("8"),
                            qsTr("9"),
                            qsTr("10"),
                            qsTr("11"),
                            qsTr("12"),
                            qsTr("13"),
                            qsTr("14"),
                            qsTr("15"),
                            qsTr("16"),
                            qsTr("17"),
                            qsTr("18"),
                            qsTr("19"),
                            qsTr("20"),
                            qsTr("21"),
                            qsTr("22"),
                            qsTr("23"),
                            qsTr("24"),
                            qsTr("25"),
                            qsTr("26"),
                            qsTr("27"),
                            qsTr("28"),
                            qsTr("29"),
                            qsTr("30"),
                            qsTr("31")
                        ]
            }
            return i18n.text[index]
        }
    }

    ListModel {
        id: repeatCycleSegmentModel

        ListElement { name: "Day" }
        ListElement { name: "1st" }
        ListElement { name: "2nd" }
        ListElement { name: "3rd" }
        ListElement { name: "4th" }
        ListElement { name: "5th" }

        function i18n(index) {
            if (i18n["text"] === undefined) {
                i18n.text = [
                            qsTr("Day"),
                            qsTr("1st"),
                            qsTr("2nd"),
                            qsTr("3rd"),
                            qsTr("4th"),
                            qsTr("5th")
                        ]
            }
            return i18n.text[index]
        }
    }

    //
    // repeat segment control
    //

    Item {
        id: repeatSegmentControl
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.bottom: parent.bottom

        Rectangle {
            id: repeatSegmentControlRect
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            anchors.topMargin: 10
            height: 25
            clip: true
            color: "black"

            GridView {
                id: segmentGrid
                anchors.fill: parent
                anchors.topMargin: 1
                anchors.leftMargin: 2
                anchors.rightMargin: 2

                cellWidth: 49; cellHeight: parent.height - 4

                model: segmentModel
                delegate: segmentCellDelegate
                highlight: Rectangle { color: "#40ffffff"; radius: 1; smooth: true; border.color: "white"; border.width: 1}
                //highlight: Rectangle { color: "#3e3c3c"; radius: 5; smooth: true; border.color: "white"; border.width: 1}

                onVisibleChanged: {
                    if (visible) {
                        segmentGrid.currentIndex = repeaterTypeSegmentSelected;
                    }
                }

                onCurrentIndexChanged: {
//                    console.debug("repeaterTypeSegmentSelected onCurrentIndexChanged")
                    repeatWeeklyDetailControl.visible = false

                    repeatMonthlyCycleSegmentControl.visible = false
                    repeatMonthlyDetailControl.visible = false

                    repeatYearlyCycleSegmentControl.visible = false
                    repeatYearlyDetailControl.visible = false
                    repeatMonthInYearlyDetailControl.visible = false

                    if (segmentGrid.currentIndex == 0) {
                        repeatDaySpecifierControl.visible = false
                    } else {
                        repeatDaySpecifierControl.visible = true

                        if (segmentGrid.currentIndex == 1) periodeQualifierText.text = qsTr("Days")
                        if (segmentGrid.currentIndex == 2) {
                            periodeQualifierText.text = qsTr("Weeks")
                            repeatWeeklyDetailControl.visible = true
                        }
                        if (segmentGrid.currentIndex == 3) {
                            periodeQualifierText.text = qsTr("Months")
                            repeatMonthlyCycleSegmentControl.visible = true
                            repeatMonthlyDetailControl.visible = true
                        }
                        if (segmentGrid.currentIndex == 4) {
                            periodeQualifierText.text = qsTr("Years")
                            repeatYearlyCycleSegmentControl.visible = true
                            repeatYearlyDetailControl.visible = true
                            repeatMonthInYearlyDetailControl.visible = true
                        }
                    }
                }

                Component {
                    id: segmentCellDelegate

                    Item {
                        id: segmentCellDelegateItem
                        width: segmentGrid.cellWidth; height: segmentGrid.cellHeight

                        MouseArea {
                            anchors.fill: parent
                            onClicked: {
                                segmentGrid.currentIndex = index;
                                repeaterTypeSegmentSelected = index;

                                updateDtsRepeatString();
                            }
                        }

//                        Column {
                        Item {
                            id: segmentCellDelegateColumn
                            anchors.topMargin: 2
                            anchors.bottomMargin: 2
                            anchors.left: parent.left
                            anchors.leftMargin: 1
                            anchors.right: parent.right
                            anchors.rightMargin: 1

                            Text {
                                //text: name;
                                text: segmentGrid.model.i18n(index)
                                font.family: "Arial";
                                font.bold: true;
                                //font.pointSize: 11;
                                font.pixelSize: 11
                                anchors.top: parent.top
                                anchors.topMargin: 4
                                anchors.horizontalCenter: parent.horizontalCenter
                                color: "white";
                                smooth: true;
                            }
                        }
                    }
                }
            }
        }
    }

    //
    // repeat day specifier control
    //

    Item {
        id: repeatDaySpecifierControl
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.bottom: parent.bottom
        visible: false

        Rectangle {
            id: repeatDaySpecifierControlRect
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            anchors.topMargin: 35
            height: 27
            clip: true
            color: "#191919"

            Text {
                text: qsTr("Every");
                horizontalAlignment: Text.AlignRight
                font.family: "Arial";
                font.bold: true;
                //font.pointSize: 11;
                font.pixelSize: 11
                anchors.top: parent.top
                anchors.topMargin: 8
                anchors.left: parent.left;
                anchors.leftMargin: 10;
                width: 65
                color: "white";
                smooth: true;
            }

            Item {
                id: repeatDaySpecifierButtonLeftControl
                width: 21; height: 21
                anchors.top: parent.top
                anchors.topMargin: 3
                anchors.left: parent.left
                anchors.leftMargin: 80

                MouseArea {
                    anchors.fill: parent
                    onClicked: {
                        repeatInterval = parseInt(repeatDaySpecifierInputNumber.text) - 1;
                        if (repeatInterval < 1) repeatInterval = 1;
                        repeatDaySpecifierInputNumber.text = repeatInterval;

                        updateDtsRepeatString();
                    }
                }

                Rectangle {
                    id: repeatDaySpecifierButtonLeftControlRect
                    anchors.fill: parent
                    clip: true
                    color: "#40ffffff"; radius: 1; smooth: true; border.color: "white"; border.width: 1

                    Text {
                        text: "<";
                        font.family: "Arial";
                        font.bold: true;
                        //font.pointSize: 11;
                        font.pixelSize: 11
                        anchors.top: parent.top
                        anchors.topMargin: 4
                        anchors.horizontalCenter: parent.horizontalCenter
                        color: "white";
                        smooth: true;
                    }
                }
            }

            Rectangle {
                id: repeatDaySpecifierInputNumberRect
                anchors.left: parent.left
                anchors.leftMargin: 110
                anchors.top: parent.top
                anchors.topMargin: 3
                width: 30
                height: 21
                color: "black"
                border.color: "white"

                TextInput {
                    id: repeatDaySpecifierInputNumber
                    text: repeatInterval
                    horizontalAlignment: Text.AlignHCenter

                    color: "#ffffff"
                    anchors.verticalCenter: parent.verticalCenter
                    anchors.left: parent.left
                    anchors.leftMargin: 2
                    anchors.right: parent.right
                    anchors.rightMargin: 2
                    //font.pointSize: 11
                    font.pixelSize: 11
                    cursorVisible: false
                    selectByMouse: true
                    selectionColor: "lightblue"
                    enabled: false
                }
            }

            Item {
                id: repeatDaySpecifierButtonRightControl
                width: 21; height: 21
                anchors.top: parent.top
                anchors.topMargin: 3
                anchors.right: parent.right
                anchors.rightMargin: 80

                MouseArea {
                    anchors.fill: parent
                    onClicked: {
                        repeatInterval = parseInt(repeatDaySpecifierInputNumber.text) + 1
                        repeatDaySpecifierInputNumber.text = repeatInterval

                        updateDtsRepeatString();
                    }
                }

                Rectangle {
                    id: repeatDaySpecifierButtonRightControlRect
                    anchors.fill: parent
                    clip: true
                    color: "#40ffffff"; radius: 1; smooth: true; border.color: "white"; border.width: 1

                    Text {
                        text: ">";
                        font.family: "Arial";
                        font.bold: true;
                        //font.pointSize: 11;
                        font.pixelSize: 11
                        anchors.top: parent.top
                        anchors.topMargin: 5
                        anchors.horizontalCenter: parent.horizontalCenter
                        color: "white";
                        smooth: true;
                    }
                }
            }

            Text {
                id: periodeQualifierText
                text: qsTr("Day");
                horizontalAlignment: Text.AlignLeft
                font.family: "Arial";
                font.bold: true;
                //font.pointSize: 11;
                font.pixelSize: 11
                anchors.top: parent.top
                anchors.topMargin: 8
                anchors.right: parent.right;
                anchors.rightMargin: 10;
                //anchors.horizontalCenter: parent.horizontalCenter
                width: 65
                color: "white";
                smooth: true;
            }
        }
    }



    //
    // repeat detail control --- weekly ----
    //

    Item {
        id: repeatWeeklyDetailControl
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.topMargin: 70
        anchors.bottom: parent.bottom
        visible: false

        Rectangle {
            id: repeatWeeklyDetailControlRect
            anchors.left: parent.left
            anchors.leftMargin: 10
            anchors.right: parent.right
            anchors.rightMargin: 10
            anchors.top: parent.top
            anchors.bottom: parent.bottom
            clip: true
            radius: 10
            color: "transparent"

            ListView  {
                id :  treeView
                anchors.top: parent.top
                anchors.left: parent.left
                anchors.right: parent.right
                anchors.bottom: parent.bottom

                model: weekdayModel
                delegate: treeDelegate

                onFocusChanged: {
//                    console.debug("treeView got Focus")
                }
            }

            Component  {
                id:  treeDelegate
                Item  {
                    id :  wrapper
                    height :  22
                    width :  treeView.width

                    Item  {
                        id:  nodeOpenElement
                        anchors.left: parent.left
                        anchors.leftMargin: 10
                        anchors.verticalCenter:  wrapper.verticalCenter
                        height:  20
                        state:  "leafnode"
                        Image  {
                            id:  triangleOpenImage
                            height: 16
                            width: 16
                            anchors.top: parent.top
                            anchors.topMargin: 2

                            source:  (weekdayCheckPattern.charAt(index) == "1") ? "qrc:IconFactory Desktop/build/ItemCheckboxWhiteChecked16.png" : "qrc:IconFactory Desktop/build/ItemCheckboxWhiteUnchecked16.png"

                            MouseArea  {
                                anchors.fill:  parent
                                onClicked:  {
                                    var replacement

                                    if (weekdayCheckPattern.charAt(index) == "0") replacement = "1"
                                    else replacement = "0"

                                    weekdayCheckPattern = weekdayCheckPattern.substring(0, index) + replacement + weekdayCheckPattern.substring(index+1)

//                                    console.debug("<<< weekdayCheckPattern:")
//                                    console.debug(weekdayCheckPattern)

                                    updateDtsRepeatString();
                                }
                            }
                        }
                    }


                    // Field  for  displaying  data  element
                    Text  {
                        id:  nameTextElement
                        //text:  name
                        text: treeView.model.i18n(index)

                        anchors.left:  nodeOpenElement.right
                        anchors.leftMargin: 25
                        anchors.top:  parent.top
                        anchors.topMargin: 4
                        anchors.bottom:  parent.bottom
                        anchors.right:  parent.right
                        color: "white"

                        //font.family: "Arial";
                        font.bold: false;
                        //font.pointSize: 12;
                        font.pixelSize: 12
                        smooth: true;
                    }

                    Rectangle  {
                        height:  1
                        anchors.top:  parent.bottom
                        anchors.left:  parent.left
                        anchors.right:  parent.right
                        color:  "#303030"
                    }
                }

            }
        }
    }


    //
    // repeat cycle segment control --- monthly ----
    //

    Item {
        id: repeatMonthlyCycleSegmentControl
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.topMargin: 52
        anchors.bottom: parent.bottom
        visible: false

        Rectangle {
            id: repeatMonthlyCycleSegmentControlRect
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            anchors.topMargin: 10
            height: 25
            clip: true
            color: "#191919"

            GridView {
                id: segmentGridMonthlyCycle
                anchors.fill: parent
                anchors.topMargin: 1
                anchors.leftMargin: 4
                anchors.rightMargin: 4

                cellWidth: 40; cellHeight: parent.height - 4

                model: repeatCycleSegmentModel
                delegate: segmentCellMonthlyCycleDelegate
                highlight: Rectangle { color: "#40ffffff"; radius: 1; smooth: true; border.color: "white"; border.width: 1}
                //highlight: Rectangle { color: "#3e3c3c"; radius: 5; smooth: true; border.color: "white"; border.width: 1}

                onVisibleChanged: {
                    if (visible) {
                        segmentGridMonthlyCycle.currentIndex = monthlySegmentSelected;
                    }
                }

                onCurrentIndexChanged: {
                    if (segmentGridMonthlyCycle.currentIndex == 0) treeViewMonthly.model = dayOfMonthModel
                    else treeViewMonthly.model = weekdayModel
                }

                Component {
                    id: segmentCellMonthlyCycleDelegate

                    Item {
                        id: segmentCellMonthlyCycleDelegateItem
                        width: segmentGridMonthlyCycle.cellWidth; height: segmentGridMonthlyCycle.cellHeight

                        MouseArea {
                            anchors.fill: parent
                            onClicked: {
                                if (segmentGridMonthlyCycle.currentIndex != index) {
                                    if (segmentGridMonthlyCycle.currentIndex == 0 || index == 0) dayOfMonthCheck = 0;

                                    segmentGridMonthlyCycle.currentIndex = index;
                                    monthlySegmentSelected = index;

                                    updateDtsRepeatString();
                                }
                            }
                        }

//                        Column {
                        Item {
                            id: segmentCellMonthlyCycleDelegateColumn
                            //anchors.top: parent.top
                            anchors.topMargin: 2
                            anchors.bottomMargin: 2
                            anchors.left: parent.left
                            anchors.leftMargin: 1
                            anchors.right: parent.right
                            anchors.rightMargin: 1

                            Text {
                                //text: name;
                                text: segmentGridMonthlyCycle.model.i18n(index)
                                font.family: "Arial";
                                font.bold: true;
                                //font.pointSize: 11;
                                font.pixelSize: 11
                                anchors.top: parent.top
                                anchors.topMargin: 4
                                anchors.horizontalCenter: parent.horizontalCenter
                                color: "white";
                                smooth: true;
                            }
                        }
                    }
                }
            }
        }
    }

    //
    // repeat detail control --- monthly ----
    //

    Item {
        id: repeatMonthlyDetailControl
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.topMargin: 90
        anchors.bottom: parent.bottom
        visible: false

        Rectangle {
            id: repeatMonthlyDetailControlRect
            anchors.left: parent.left
            anchors.leftMargin: 10
            anchors.right: parent.right
            anchors.rightMargin: 10
            anchors.top: parent.top
            anchors.bottom: parent.bottom
            clip: true
            radius: 10
            color: "transparent"

            ListView  {
                id :  treeViewMonthly
                anchors.top: parent.top
                anchors.left: parent.left
                anchors.right: parent.right
                anchors.bottom: parent.bottom

                model: dayOfMonthModel
                delegate: monthlytreeDelegate

                onFocusChanged: {
//                    console.debug("treeView got Focus")
                }
            }

            Component  {
                id:  monthlytreeDelegate
                Item  {
                    id :  wrapperMonthly
                    height :  22
                    width :  treeViewMonthly.width

                    Item  {
                        id:  nodeOpenElementMonthly
                        anchors.left:  parent.left
                        anchors.leftMargin: 10
                        anchors.verticalCenter:  wrapperMonthly.verticalCenter
                        height:  20
                        state:  "leafnode"
                        Image  {
                            id:  triangleOpenImageMonthly
                            height: 16
                            width: 16
                            anchors.top: parent.top
                            anchors.topMargin: 2

                            source:  (dayOfMonthCheck == index+1) ? "qrc:IconFactory Desktop/build/ItemCheckboxWhiteChecked16.png" : "qrc:IconFactory Desktop/build/ItemCheckboxWhiteUnchecked16.png"

                            MouseArea  {
                                anchors.fill:  parent
                                onClicked:  {
//                                    console.debug("Item Clicked -> ")
//                                    console.debug(name)

                                    dayOfMonthCheck = index + 1

                                    updateDtsRepeatString();
                                }
                            }
                        }
                    }


                    // Field  for  displaying  data  element
                    Text  {
                        id:  nameTextElementMonthly
                        //text:  name
                        text: treeViewMonthly.model.i18n(index)

                        anchors.left:  nodeOpenElementMonthly.right
                        anchors.leftMargin: 25
                        anchors.top:  parent.top
                        anchors.topMargin: 4
                        anchors.bottom:  parent.bottom
                        anchors.right:  parent.right
                        color: "white"

                        //font.family: "Arial";
                        font.bold: false;
                        //font.pointSize: 12;
                        font.pixelSize: 12
                        smooth: true;
                    }

                    Rectangle  {
                        height:  1
                        anchors.top:  parent.bottom
                        anchors.left:  parent.left
                        anchors.right:  parent.right
                        color:  "#303030"
                    }
                }

            }
        }
    }

    //
    // repeat cycle segment control --- yearly ----
    //

    Item {
        id: repeatYearlyCycleSegmentControl
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.topMargin: 52
        anchors.bottom: parent.bottom
        visible: false

        Rectangle {
            id: repeatYearlyCycleSegmentControlRect
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            anchors.topMargin: 10
            height: 25
            clip: true
            color: "#191919"

            GridView {
                id: segmentGridYearlyCycle
                anchors.fill: parent
                anchors.topMargin: 1
                anchors.leftMargin: 4
                anchors.rightMargin: 4

                cellWidth: 40; cellHeight: parent.height - 4

                model: repeatCycleSegmentModel
                delegate: segmentCellYearlyCycleDelegate
                highlight: Rectangle { color: "#40ffffff"; radius: 1; smooth: true; border.color: "white"; border.width: 1}
                //highlight: Rectangle { color: "#3e3c3c"; radius: 5; smooth: true; border.color: "white"; border.width: 1}

                onVisibleChanged: {
                    if (visible) {
                        segmentGridYearlyCycle.currentIndex = yearlySegmentSelected;
                    }
                }

                onCurrentIndexChanged: {
                    if (segmentGridYearlyCycle.currentIndex == 0) treeViewYearly.model = dayOfMonthModel
                    else treeViewYearly.model = weekdayModel
                }

                Component {
                    id: segmentCellYearlyCycleDelegate

                    Item {
                        id: segmentCellYearlyCycleDelegateItem
                        width: segmentGridYearlyCycle.cellWidth; height: segmentGridYearlyCycle.cellHeight

                        MouseArea {
                            anchors.fill: parent
                            onClicked: {
                                if (segmentGridYearlyCycle.currentIndex != index) {
                                    if (segmentGridYearlyCycle.currentIndex == 0 || index == 0) dayInYearCheck = 0;

                                    segmentGridYearlyCycle.currentIndex = index;
                                    yearlySegmentSelected = index;

                                    updateDtsRepeatString();
                                }
                            }
                        }

//                        Column {
                        Item {
                            id: segmentCellYearlyCycleDelegateColumn
                            //anchors.top: parent.top
                            anchors.topMargin: 2
                            anchors.bottomMargin: 2
                            anchors.left: parent.left
                            anchors.leftMargin: 1
                            anchors.right: parent.right
                            anchors.rightMargin: 1

                            Text {
                                //text: name;
                                text: segmentGridYearlyCycle.model.i18n(index)
                                font.family: "Arial";
                                font.bold: true;
                                //font.pointSize: 11;
                                font.pixelSize: 11
                                anchors.top: parent.top
                                anchors.topMargin: 4
                                anchors.horizontalCenter: parent.horizontalCenter
                                color: "white";
                                smooth: true;
                            }
                        }
                    }
                }
            }
        }
    }

    //
    // repeat detail control for month --- yearly ----
    //

    Item {
        id: repeatMonthInYearlyDetailControl
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.rightMargin: 125
        anchors.top: parent.top
        anchors.topMargin: 90
        anchors.bottom: parent.bottom
        visible: false

        Rectangle {
            id: repeatMonthInYearlyDetailControlRect
            anchors.left: parent.left
            anchors.leftMargin: 10
            anchors.right: parent.right
            anchors.rightMargin: 10
            anchors.top: parent.top
            anchors.bottom: parent.bottom
            clip: true
            radius: 10
            color: "transparent"

            ListView  {
                id :  treeViewMonthInYearly
                anchors.top: parent.top
                anchors.left: parent.left
                anchors.right: parent.right
                anchors.bottom: parent.bottom

                model: nameOfMonthModel
                delegate: monthInYearlytreeDelegate

                onFocusChanged: {
//                    console.debug("treeView got Focus")
                }
            }

            Component  {
                id:  monthInYearlytreeDelegate
                Item  {
                    id :  wrapperMonthInYearly
                    height :  22
                    width :  treeViewMonthInYearly.width

                    Item  {
                        id:  nodeOpenElementMonthInYearly
                        anchors.left:  parent.left
                        anchors.leftMargin: 10
                        anchors.verticalCenter:  wrapperMonthInYearly.verticalCenter
                        height:  20
                        state:  "leafnode"
                        Image  {
                            id:  triangleOpenImageMonthInYearly
                            height: 16
                            width: 16
                            anchors.top: parent.top
                            anchors.topMargin: 2

                            source:  (monthInYearCheck == index+1) ? "qrc:IconFactory Desktop/build/ItemCheckboxWhiteChecked16.png" : "qrc:IconFactory Desktop/build/ItemCheckboxWhiteUnchecked16.png"

                            MouseArea  {
                                anchors.fill:  parent
                                onClicked:  {
//                                    console.debug("Item Clicked -> ")
//                                    console.debug(name)

                                    monthInYearCheck = index + 1

                                    updateDtsRepeatString();
                                }
                            }
                        }
                    }


                    // Field  for  displaying  data  element
                    Text  {
                        id:  nameTextElementMonthInYearly
                        //text: name
                        text: treeViewMonthInYearly.model.i18n(index)

                        anchors.left:  nodeOpenElementMonthInYearly.right
                        anchors.leftMargin: 25
                        anchors.top:  parent.top
                        anchors.topMargin: 4
                        anchors.bottom:  parent.bottom
                        anchors.right:  parent.right
                        color: "white"

                        //font.family: "Arial";
                        font.bold: false;
                        //font.pointSize: 12;
                        font.pixelSize: 12
                        smooth: true;
                    }

                    Rectangle  {
                        height:  1
                        anchors.top:  parent.bottom
                        anchors.left:  parent.left
                        anchors.right:  parent.right
                        color:  "#303030"
                    }
                }

            }
        }
    }

    //
    // repeat detail control for day --- yearly ----
    //

    Item {
        id: repeatYearlyDetailControl
        anchors.left: parent.left
        anchors.leftMargin: 125
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.topMargin: 90
        anchors.bottom: parent.bottom
        visible: false

        Rectangle {
            id: repeatYearlyDetailControlRect
            anchors.left: parent.left
            anchors.leftMargin: 10
            anchors.right: parent.right
            anchors.rightMargin: 10
            anchors.top: parent.top
            anchors.bottom: parent.bottom
            clip: true
            radius: 10
            color: "transparent"

            ListView  {
                id :  treeViewYearly
                anchors.top: parent.top
                anchors.left: parent.left
                anchors.right: parent.right
                anchors.bottom: parent.bottom

                model: dayOfMonthModel
                delegate: yearlytreeDelegate

                onFocusChanged: {
//                    console.debug("treeView got Focus")
                }
            }

            Component  {
                id:  yearlytreeDelegate
                Item  {
                    id :  wrapperYearly
                    height :  22
                    width :  treeViewYearly.width

                    Item  {
                        id:  nodeOpenElementYearly
                        anchors.left:  parent.left
                        anchors.leftMargin: 10
                        anchors.verticalCenter:  wrapperYearly.verticalCenter
                        height:  20
                        state:  "leafnode"
                        Image  {
                            id:  triangleOpenImageYearly
                            height: 16
                            width: 16
                            anchors.top: parent.top
                            anchors.topMargin: 2

                            source:  (dayInYearCheck == index+1) ? "qrc:IconFactory Desktop/build/ItemCheckboxWhiteChecked16.png" : "qrc:IconFactory Desktop/build/ItemCheckboxWhiteUnchecked16.png"

                            // Catches  clicking  the mouse  and  open / close  element
                            MouseArea  {
                                anchors.fill:  parent
                                onClicked:  {
//                                    console.debug("Item Clicked -> ")
//                                    console.debug(name)

                                    dayInYearCheck = index + 1

                                    updateDtsRepeatString();
                                }
                            }
                        }
                    }


                    // Field  for  displaying  data  element
                    Text  {
                        id:  nameTextElementYearly
                        //text: name
                        text: treeViewYearly.model.i18n(index)

                        anchors.left:  nodeOpenElementYearly.right
                        anchors.leftMargin: 25
                        anchors.top:  parent.top
                        anchors.topMargin: 4
                        anchors.bottom:  parent.bottom
                        anchors.right:  parent.right
                        color: "white"

                        //font.family: "Arial";
                        font.bold: false;
                        //font.pointSize: 12;
                        font.pixelSize: 12
                        smooth: true;
                    }

                    Rectangle  {
                        height:  1
                        anchors.top:  parent.bottom
                        anchors.left:  parent.left
                        anchors.right:  parent.right
                        color:  "#303030"
                    }
                }

            }
        }
    }

}
