import Qt 4.7

//
// window title bar notepad > yellowish
//

Item {
    id: maincomponent

    property string windowTitle: ""
    property string windowGotFocus: "0"
    property string platformID: "MAC"
    property bool windowDrawBorder: false
    property alias radius: titlebarBackgroundTop.radius

    anchors.fill: parent

    Rectangle {
        id: background

        opacity: 0.75
        color: "#fdfdcf"

        border.width: (windowDrawBorder ? 1 : 0)
        border.color: "black"

        radius: (maincomponent.platformID == "WIN" ? 0 : 6)
        smooth: true
        anchors.fill: parent
        clip: true

        Item {
            id: titlebarBackgroundTopClip
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            height: 10
            clip: true

            Rectangle {
                id: titlebarBackgroundTop
                anchors.left: parent.left
                anchors.right: parent.right
                anchors.top: parent.top
                height: 19
                clip: true

                radius: (maincomponent.platformID == "WIN" ? 0 : 6)
                smooth: true
                opacity: 0.3

                color: (windowGotFocus == "1") ? "#ffffff" : "#00000000"
            }

            Rectangle {
                id: titlebarBackgroundTopLine
                anchors.left: parent.left
                anchors.right: parent.right
                anchors.top: parent.top
                anchors.leftMargin: 6
                anchors.rightMargin: 6
                height: 0.5

                radius: 0
                smooth: true
                opacity: 0.6
                color: "#dddddd"
            }
        }


        Rectangle {
            id: titlebarBackgroundBottom
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            anchors.topMargin: 10
            height: 9

            radius: 0

            opacity: 0.2
            color: (windowGotFocus == "1") ? "#aaaaaa" : "#00000000"
        }

        Rectangle {
            id: titlebarBackgroundBottomLine
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            anchors.topMargin: 19
            height: 0.5

            radius: 0
            smooth: true
            opacity: 0.6
            color: "#444444"
        }



        Text {
            id: labelWindowTitleShadow
            anchors.right: parent.right
            anchors.left: parent.left
            anchors.leftMargin: 25
            anchors.top: parent.top
            //height: 19
            anchors.topMargin: 4
            color: "white"
            text: windowTitle
            clip: true
            //font.family: "Helvetica"
            font.family: "Arial"
            font.bold: true
            //font.pointSize: 11
            font.pixelSize: 11
            verticalAlignment: Text.AlignVCenter
            horizontalAlignment: Text.AlignHCenter
            smooth: true

            opacity: 1
        }

        Text {
            id: labelWindowTitle
            anchors.right: parent.right
            anchors.left: parent.left
            anchors.leftMargin: 25
            anchors.top: parent.top
            //height: 19
            anchors.topMargin: 3
            //color: "#444444"
            color: "#222222"
            text: windowTitle
            clip: true
            //font.family: "Helvetica"
            font.family: "Arial"
            font.bold: true
            //font.pointSize: 11
            font.pixelSize: 11
            verticalAlignment: Text.AlignVCenter
            horizontalAlignment: Text.AlignHCenter
            smooth: true

            opacity: 1
        }

        MouseArea {
            id: titlebarDragArea
            x: 0
            y: 0
            width: 300
            height: 19
            clip: false
            visible: true
            anchors.right: parent.right
            anchors.left: parent.left
            anchors.top: parent.top
            acceptedButtons: Qt.LeftButton

            onPressed: {
                QtHandler.startMoveTrigger(mouseX, mouseY)
            }
            onPositionChanged: {
                QtHandler.moveTrigger(mouseX, mouseY);
            }
        }
    }

    Image {
        id: titlebarCloseImage
        x: (maincomponent.platformID == "MAC") ? 5 : maincomponent.width - 52
        y: (maincomponent.platformID == "MAC") ? 4 : 1
        width: (maincomponent.platformID == "MAC") ? 12 : 46
        height: (maincomponent.platformID == "MAC") ? 12 : 18

        opacity: (maincomponent.platformID == "WIN" ? 1 : 0.68)
        source: (maincomponent.platformID == "MAC") ? "pics/PreviewIconCloseButton12px.png" : "qrc:/icons2/CloseIconWindows8.png"

        MouseArea {
            id: titlebarCloseImageMouseArea
            anchors.fill: parent

            onClicked: {
                QtHandler.CloseButtonClicked();
            }
        }
    }
}
